paquetesApp/urls.py
from django.urls import path
from . import views

app_name = "paquetesApp"
urlpatterns = [
    path('',views.home, name='home'),
    path('oficinas/', views.oficinas,name='oficinas'),
    path('paquetes/', views.paquetes, name='paquetes'),
    path('liquidar/<int:paquete_id>', views.liquidar, name='liquidar')
]

tracking/urls.py
from django.contrib import admin
from django.urls import path, include
from paquetesApp import views


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('paquetesApp.urls'))
] 

paquetesApp/models.py
from datetime import date
from django.contrib.auth.models import User
from django.db import models
from django.db.models.signals import post_save
from django.dispatch import receiver

# Create your models here.
class Oficina(models.Model):
    estado = models.CharField(max_length=256)
    ciudad = models.CharField(max_length=256)
    nombre = models.CharField(max_length=256)
    # contacto= models.CharField(max_length=256)
    # telefono = models.CharField(max_length=256)

    def __str__(self):
        return self.nombre

class Paquete(models.Model):
    TIPOS= (
        ('C','Alimentos'),
        ('R','Textiles/Prendas'),
        ('M','Medicamentos'),
        ('O','Otros')   
    )
    ESTADO =(
        ('O', 'En oficina'),
        ('L', 'Liquidado'),
        ('D', 'Devolucion')
    )
    codigo= models.CharField(max_length=10,unique=True)
    office = models.ForeignKey( Oficina, related_name="paquetes", on_delete=models.DO_NOTHING)
    tipo = models.CharField(max_length=1, choices=TIPOS)
    nombre_destinatario = models.CharField(max_length=256,null=True)
    telefono_destinatario=models.CharField(max_length=20, null=True)
    peso= models.IntegerField(null=True)
    estado= models.CharField(choices= ESTADO, max_length=1,default='O')
    created_at= models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.codigo   

paquetesApp/forms.py
# dwitter/forms.py

from django import forms
from .models import Oficina,Paquete

class OficinaForm(forms.ModelForm):
    ciudad = forms.CharField(
        required=True,
        widget=forms.widgets.TextInput(
            attrs={
                "placeholder": "Ciudad",
                "class": "input is-success is-medium is-round mr-6",
                "value": "San Francisco"
            }
        ),
        label="",
    )        
    estado = forms.CharField(
        required=True,
        widget=forms.widgets.TextInput(
            attrs={
                "placeholder": "Estado",
                "class": "input is-success is-medium is-round mr-6",
            }
        ),
        label="",
    )

    nombre = forms.CharField(
        required=True,
        widget=forms.widgets.TextInput(
            attrs={
                "placeholder": "Nombre",
                "class": "input is-success is-medium is-round mr-6",
            }
        ),
        label="",
    )
    class Meta:
        model= Oficina
        fields = '__all__' 

class PaqueteForm(forms.ModelForm):
    TIPOS= (
        ('C','Alimentos'),
        ('R','Textiles/Prendas'),
        ('M','Medicamentos'),
        ('O','Otros')   
    )
    ESTADOS =(
        ('O', 'En oficina'),
        ('L', 'Liquidado'),
        ('D', 'Devolucion')
    )    
    codigo = forms.CharField(
        required=True,
        widget= forms.widgets.NumberInput(
            attrs={
                "placeholder": "Codigo Paquete",
                "class": "input is-success is-medium is-round mr-6"
            }
        ),
        label=""

    )
    office = forms.ModelChoiceField(
        required= True,
        to_field_name= 'id',
        queryset= Oficina.objects.all(),
        label=""
    )
    tipo = forms.ChoiceField(
        required= True, 
        choices= TIPOS, 
        label=""
    )
    nombre_destinatario= forms.CharField(
        required=False,
        widget=forms.widgets.TextInput(
            attrs={
                "placeholder": "Destinatario",
                "class": "input is-success is-medium is-round mr-6"
            }
        ),
        label="",
    )   
    telefono_destinatario= forms.CharField(
        required=False,
        widget=forms.widgets.TextInput(
            attrs={
                "placeholder": "Telefono",
                "class": "input is-success is-medium is-round mr-6"
            }
        ),
        label="",
    ) 
    peso = forms.DecimalField(
        max_value= 10000,
        max_digits= 4,
        required=False, 
        widget= forms.widgets.NumberInput(
            attrs={
                "placeholder": "Peso (lb)",
                "class": "input is-success is-medium is-round mr-6"
            }
            ),
            label=""


    )
    estado = forms.ChoiceField(
        required= True, 
        choices= ESTADOS, 
        label=""
    )    
    class Meta:
        model= Paquete
        fields = '__all__'         

paquetesApp/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponse
from .models import Oficina, Paquete
from .forms import OficinaForm, PaqueteForm
from django.contrib import messages


def home(request):
    return render(request, 'paquetesApp/home.html', {})

def oficinas(request):
    oficinas= Oficina.objects.all();
    form = OficinaForm(request.POST or None)

    if request.method == "POST":
        if form.is_valid():
            oficina = form.save(commit=False)
            oficina.save()
            messages.success(request, ('Oficina creada correctamente!'))
            return redirect("paquetesApp:oficinas")
    else:
        return render(request,  'paquetesApp/oficinas.html',{"form":form, "oficinas":oficinas})

def paquetes(request):
    paquetes = Paquete.objects.all().order_by("-created_at")
    form = PaqueteForm(request.POST or None)
    if request.method == "POST":
        if form.is_valid():
            paquete = form.save(commit=False)
            paquete.save()
            return redirect("paquetesApp:paquetes") 
    return render(request, 'paquetesApp/paquetes.html',{"form": form, "paquetes": paquetes})

def liquidar(request, paquete_id):
    paquete = Paquete.objects.get(id=paquete_id)
    paquete.estado= "L"
    paquete.save()
    messages.success(request, (f'{paquete.codigo}'+ " liquidado correctamente"))
    return redirect("paquetesApp:paquetes")
   

paquetesApp/templates/paquetesApp/base.html
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Ruta SanFrancisco</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.8.2/css/bulma.min.css">
    <script defer src="https://use.fontawesome.com/releases/v5.3.1/js/all.js"></script>
    <style>
    .menu {
        position: sticky;
        display: inline-block;
        vertical-align: top;
        max-height: 100vh;
        overflow-y: auto;
        top: 0;
        width: inherit;
        bottom: 0;
        padding: 30px;
      }
      
      .content {
        display: inline-block;
      }  
    </style>  
</head>
<body>
    <nav class="navbar is-light" role="navigation" aria-label="main navigation">
        <div class="navbar-brand">
            <a class="navbar-item" href="https://bulma.io">
                <img src="https://images.vexels.com/media/users/3/163320/isolated/lists/020f34e9583ae2c28ab667bc9bc36a86-san-francisco-bridge-sky-scraper-skyline-sticker.png" >
            </a>
        </div>
    
        <div class="navbar-menu">
            <div class="navbar-start">
                <a class="navbar-item" href="http://127.0.0.1:8000/paquetes/">
                    Paquetes
                </a>                   
                <a class="navbar-item" href="http://127.0.0.1:8000/oficinas/">
                    Oficinas
                </a>
             
            </div>
    
            <!-- <div class="navbar-end">
                <div class="navbar-item">
                    <form>
                        <div class="field has-addons">
                            <div class="control">
                                <input class="input" type="text" placeholder="Add Todo">
                            </div>
                            <div class="control">
                                <button type="submit" class="button is-link">Submit</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div> -->
        </div>
    </nav>
    <section class="section">
        {% if messages %}
            {% for message in messages %}
                <article class="message is-success">
                    <div class="message-header">
                        <p>Operacion Exitosa</p>
                    </div>
                    <div class="message-body">
                        {{ message }}
                    </div>
                </article>
            {% endfor %}
        {% endif %}
    </section>
<div class="columns">
{% block content %}

{% endblock content %}
</div>
</body>
</html>

paquetesApp/templates/paquetesApp/home.html
{% extends 'paquetesApp/base.html' %}

{% block content %}
    <section class="section">
        <div class="container">
            <h1 class="title">
                Hello from home.html
            </h1>
        </div>
    </section>
{% endblock %} 

paquetesApp/templates/paquetesApp/oficinas.html
{% extends 'paquetesApp/base.html' %}

{% block content %}

<div class="column is-9">
        {% comment %} {% for oficina in oficinas %} {% endcomment %}
        <!-- <div class="block"> -->
            {% comment %} <div class="card">
                <div class="card-content">
                    <div class="media">
                        <div class="media-content">
                            <p class="title is-3">{{ oficina.nombre }}</p>
                            <p class="subtitle is-5"> {{oficina.ciudad}}-{{ oficina.estado }}</p>
                            <p class="subtitle is-6">Editar</p>
                        </div>
                    </div>
                </div>

            </div> {% endcomment %}
        <!-- </div> -->
        {% comment %} {% endfor %} {% endcomment %}
        <table class="table is-hoverable is-fullwidth">
            <thead>
                <tr>
                    <th>Ciudad</th>
                    <th>Nombre</th>
                    <th>Eliminar</th>
                </tr>
            </thead>
            {% for oficina in oficinas %}
            <tr>
                <td>
                    {{oficina.ciudad}}-{{ oficina.estado }}
                </td>
                <td>
                    {{ oficina.nombre }}
                </td>
                <td>
                    Eliminar oficina.
                </td>
            </tr>
            {% endfor %}
        </table>   
</div>
<div class="column is-6"  >
    {% comment %} <div class="section" > {% endcomment %}
    <aside class= "menu">
        <div class="block">
            <h2 class="title is-2">Agregar oficina</p>
        </div>
        <div class="block">
            <form method="post">
                {% csrf_token %}
                {% for field in form %}                            
                    <div class="field is-horizontal px-4">
                        <div class="field-body px-4">
                            <div class="field px-4">
                                <p class="control px-4">
                                    {{ field.errors }}
                                    {{ field }}
                                    {% if field.help_text %}
                                        <p class="help">{{ field.help_text|safe }}</p>
                                    {% endif %}                                    
                                </p>
                            </div>
                        </div>
                    </div>                    
                    {% comment %} <div class="field-body">  
                            <div class="field">
                                {{ field.errors }}
                                <p class="control">
                                    {{ field }}
                                </p>
                            </div>       
                        {% if field.help_text %}
                            <p class="help">{{ field.help_text|safe }}</p>
                        {% endif %}
                    </div>                  {% endcomment %}
                {% endfor %}                
              
                <button class="button is-success is-fullwidth is-medium mt-5" type="submit">Agregar
                </button>
            </form>
        </div>
    </aside>
    {% comment %} </div> {% endcomment %}

</div>


{% endblock content %}

paquetesApp/templates/paquetesApp/paquetes.html
{% extends 'paquetesApp/base.html' %}

{% block content %}

<div id="result" class="column is-9">
        {% for paquete in paquetes %}
        <div class="block"> 
           <div class="card">
                <div class="card-content">
                    <div class="media">
                        <div class= "media-left">
                            <p class="title is-4 has-text-centered">{{ paquete.codigo }}</p>
                           
                        </div>
                        <div class="media-content">                        
                            {% comment %} <p class="subtitle is-5"> {{paquete.office.nombre}}-{{ paquete.office.ciudad }}</p> {% endcomment %}
                            <p class="subtitle is-5"> {{paquete.office.nombre}}-{{ paquete.office.ciudad }}</p>
                            <p class="subtitle is-5"> {{paquete.get_estado_display}} </p>                        
                            <p class="title is-5"> {{paquete.peso}} lb</p>
                            <p><div class="field is-grouped">
                                <div class="control">
                                    <a
                                    href="{% url 'paquetesApp:liquidar' paquete.id %}"
                                    ><button class="button is-link">Liquidar</button><a>
                                </div>
                                <div class="control">
                                  <button class="button is-link is-light">Devolucion</button>
                                </div>
                            </div>
                            </p>
             

                              
                                
                                {% comment %} <a> Devolucion </a> {% endcomment %}
                       
                            
                        </div>
                    </div>
                </div>

            </div> 
        </div>
        {% endfor %}

        {% comment %} <table class="table is-hoverable is-fullwidth">
            <thead>
                <tr>
                    <th>Ciudad</th>
                    <th>Nombre</th>
                    <th>Eliminar</th>
                </tr>
            </thead>
            {% for oficina in oficinas %}
            <tr>
                <td>
                    {{oficina.ciudad}}-{{ oficina.estado }}
                </td>
                <td>
                    {{ oficina.nombre }}
                </td>
                <td>
                    Eliminar oficina.
                </td>
            </tr>
            {% endfor %}
        </table>    {% endcomment %}
</div>
<div class="column is-22"  >
    {% comment %} <div class="section" > {% endcomment %}
    <aside class= "menu">
        <div class="block">
            <h2 class="title is-3">Agregar Paquete</p>  
        </div>
        <div class="block">
            <form method="post">
                {% csrf_token %}
                {{form.non_field_errors}}
                {% comment %} CODIGO {% endcomment %}
                <div class="field is-horizontal px-4">
                 
                    <div class="field-body px-4">
                        <div class="field px-4">
                            {{form.codigo}} 
                        </div>
                    </div>
                </div>    
                {% comment %} Oficina {% endcomment %}
                <div class="field is-horizontal px-4">
                 
                    <div class="field-body px-4">
                        <div class="field px-4">
                            <div class="select">
                            {{form.office}}
                            </div> 
                        </div>
                    </div>
                </div>  
                {% comment %} Tipo {% endcomment %}
                <div class="field is-horizontal px-4">
                 
                    <div class="field-body px-4">
                        <div class="field px-4">
                            <div class="select">
                            {{form.tipo}}
                            </div> 
                        </div>
                    </div>
                </div>                  
                {% comment %} Nombre Destinatario {% endcomment %}
                <div class="field is-horizontal px-4">
                 
                    <div class="field-body px-4">
                        <div class="field px-4">
                            {{form.nombre_destinatario}} 
                        </div>
                    </div>
                </div>         
                {% comment %} Telefon Destinatario {% endcomment %}
                <div class="field is-horizontal px-4">
                 
                    <div class="field-body px-4">
                        <div class="field px-4">
                            {{form.telefono_destinatario}} 
                        </div>
                    </div>
                </div>    
                {% comment %} Peso {% endcomment %}
                <div class="field is-horizontal px-4">
                 
                    <div class="field-body px-4">
                        <div class="field px-4">
                            {{form.peso}} 
                        </div>
                    </div>
                </div>  
                {% comment %}Estado{% endcomment %}
                <div class="field is-horizontal px-4">
                 
                    <div class="field-body px-4">
                        <div class="field px-4">
                            <div class="select">
                            {{form.estado}}
                            </div> 
                        </div>
                    </div>
                </div>                                                                              
                <button class="button is-success is-fullwidth is-medium mt-5" type="submit">Agregar
                </button>
            </form>
        </div>
    </aside>
    {% comment %} </div> {% endcomment %}

</div>


{% endblock content %}